; This file is part of Intellidiscs.

; Intellidiscs is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; Intellidiscs is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with Intellidiscs.  If not, see <http://www.gnu.org/licenses/>.

; Copyright 2021 Phaser Cat Games LLC

; Various data assets

    org $b000
game_display_list
    .byte $70,$70,$70 ; Overscan.
    .byte $c7,$00,$20 ; Score line.
    .byte $04,$04     ; Playfield is 22 lines of mode 4.
    .byte $04,$04,$04,$04,$04,$04,$04,$04,$04,$04
    .byte $04,$04,$04,$04,$04,$04,$04,$04,$04,$04
    .byte $41
    .word game_display_list

title_display_list
    .byte $70,$70,$70 ; Overscan.
    .byte $42,$20,$02,$02,$02 ; High/low/last score lines.
    .byte $70 ; Make some space.
    .byte $cc ; Title logo area.
    .word title_logo
    .byte $0c,$0c,$0c,$0c,$0c ; 29 rows.
    .byte $0c,$0c,$0c,$0c,$0c
    .byte $0c,$0c,$0c,$0c,$0c
    .byte $0c,$0c,$0c,$0c,$0c
    .byte $0c,$0c,$0c,$0c,$0c
    .byte $0c,$0c,$0c
    .byte $42,$28,$30
    .byte $02,$02,$02,$02 ; Text all the way down.
    .byte $02,$02,$02,$02,$02
    .byte $02,$02,$02,$02,$02
    .byte $02,$02
    .byte $41
    .word title_display_list

license_display_list
    .byte $70,$70,$70 ; Overscan.
    .byte $42
    .word gpl_text
    .byte $02,$02,$02,$02,$02
    .byte $02,$70,$02,$02,$02,$02
    .byte $02,$02,$70,$02,$02,$02
    .byte $02,$70,$02
    .byte $41
    .word license_display_list

; Player sprite frames.
player_sprite_vertical_1
    .byte   %00000000
    .byte   %00011000
    .byte   %00011000
    .byte   %00000000
    .byte   %00111100
    .byte   %01111110
    .byte   %01011010
    .byte   %01011010
    .byte   %01011010
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %00000000

player_sprite_vertical_2
    .byte   %00000000
    .byte   %00011000
    .byte   %00011000
    .byte   %00000000
    .byte   %00111100
    .byte   %01111100
    .byte   %01011010
    .byte   %00011010
    .byte   %00011000
    .byte   %00011010
    .byte   %00011000
    .byte   %00011000
    .byte   %00010000
    .byte   %00010000
    .byte   %00000000
    .byte   %00010000
    .byte   %00000000

player_sprite_vertical_3
    .byte   %00000000
    .byte   %00011000
    .byte   %00011000
    .byte   %00000000
    .byte   %00111100
    .byte   %00111110
    .byte   %01011010
    .byte   %01011000
    .byte   %00011000
    .byte   %01011000
    .byte   %00011000
    .byte   %00011000
    .byte   %00001000
    .byte   %00001000
    .byte   %00000000
    .byte   %00001000
    .byte   %00000000

player_sprite_left_1
    .byte   %00000000
    .byte   %01100000
    .byte   %00100000
    .byte   %01100000
    .byte   %00110000
    .byte   %00110000
    .byte   %00110000
    .byte   %00110000
    .byte   %01110000
    .byte   %00110000
    .byte   %00110000
    .byte   %00110000
    .byte   %00110000
    .byte   %00111100
    .byte   %00010100
    .byte   %00110000
    .byte   %00000000

player_sprite_left_2
    .byte   %00000000
    .byte   %01100000
    .byte   %00100000
    .byte   %01100000
    .byte   %00110000
    .byte   %00111000
    .byte   %00111000
    .byte   %01111000
    .byte   %00011000
    .byte   %00111000
    .byte   %01111100
    .byte   %01000010
    .byte   %01110010
    .byte   %00010010
    .byte   %00000010
    .byte   %00000100
    .byte   %00000000

player_sprite_left_3
    .byte   %00000000
    .byte   %01100000
    .byte   %00100000
    .byte   %01100000
    .byte   %00111000
    .byte   %00111100
    .byte   %01110100
    .byte   %00110100
    .byte   %00110000
    .byte   %00111000
    .byte   %11111110
    .byte   %10000010
    .byte   %11100010
    .byte   %00100001
    .byte   %00000001
    .byte   %00000001
    .byte   %00000000

player_sprite_left_4
    .byte   %00000000
    .byte   %00110000
    .byte   %00010000
    .byte   %00110000
    .byte   %00011110
    .byte   %00011010
    .byte   %01111010
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %01111100
    .byte   %01000100
    .byte   %00100110
    .byte   %00100010
    .byte   %00000011
    .byte   %00000001
    .byte   %00000000

player_sprite_left_5
    .byte   %00000000
    .byte   %00110000
    .byte   %00010000
    .byte   %00111110
    .byte   %00011010
    .byte   %11111010
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %11111100
    .byte   %10000100
    .byte   %10000110
    .byte   %10000010
    .byte   %00000011
    .byte   %00000001
    .byte   %00000000

player_sprite_left_6
    .byte   %00000000
    .byte   %00110000
    .byte   %00010000
    .byte   %00110000
    .byte   %00011110
    .byte   %00011010
    .byte   %11111000
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %00111100
    .byte   %00100100
    .byte   %01100110
    .byte   %01000011
    .byte   %01000001
    .byte   %11000001
    .byte   %00000000

player_sprite_left_7
    .byte   %00000000
    .byte   %01100000
    .byte   %00100000
    .byte   %01100000
    .byte   %00111000
    .byte   %00111100
    .byte   %01110100
    .byte   %00110100
    .byte   %00110000
    .byte   %00110000
    .byte   %00011100
    .byte   %00111100
    .byte   %00100100
    .byte   %00100111
    .byte   %00100001
    .byte   %01100000
    .byte   %00000000

player_sprite_left_8
    .byte   %00000000
    .byte   %01100000
    .byte   %00100000
    .byte   %01100000
    .byte   %00110000
    .byte   %00111000
    .byte   %00111000
    .byte   %01111000
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %00011111
    .byte   %00010001
    .byte   %00010001
    .byte   %00010000
    .byte   %00110000
    .byte   %00000000

player_sprite_right_1
    .byte   %00000000
    .byte   %00000110
    .byte   %00000100
    .byte   %00000110
    .byte   %00001100
    .byte   %00001100
    .byte   %00001100
    .byte   %00001100
    .byte   %00001110
    .byte   %00001100
    .byte   %00001100
    .byte   %00001100
    .byte   %00001100
    .byte   %00111100
    .byte   %00101000
    .byte   %00001100
    .byte   %00000000

player_sprite_right_2
    .byte   %00000000
    .byte   %00000110
    .byte   %00000100
    .byte   %00000110
    .byte   %00001100
    .byte   %00011100
    .byte   %00011100
    .byte   %00011110
    .byte   %00011000
    .byte   %00011100
    .byte   %00111110
    .byte   %01000010
    .byte   %01001110
    .byte   %01001000
    .byte   %01000000
    .byte   %00100000
    .byte   %00000000

player_sprite_right_3
    .byte   %00000000
    .byte   %00000110
    .byte   %00000100
    .byte   %00000110
    .byte   %00011100
    .byte   %00111100
    .byte   %00101110
    .byte   %00101100
    .byte   %00001100
    .byte   %00011100
    .byte   %01111111
    .byte   %01000001
    .byte   %01000111
    .byte   %10000100
    .byte   %10000000
    .byte   %10000000
    .byte   %00000000

player_sprite_right_4
    .byte   %00000000
    .byte   %00001100
    .byte   %00001000
    .byte   %00001100
    .byte   %01111000
    .byte   %01011000
    .byte   %01011110
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %00111110
    .byte   %00100010
    .byte   %01100100
    .byte   %01000100
    .byte   %11000000
    .byte   %10000000
    .byte   %00000000

player_sprite_right_5
    .byte   %00000000
    .byte   %00001100
    .byte   %00001000
    .byte   %01111100
    .byte   %01011000
    .byte   %01011111
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %00111111
    .byte   %00100001
    .byte   %01100001
    .byte   %01000001
    .byte   %11000000
    .byte   %10000000
    .byte   %00000000

player_sprite_right_6
    .byte   %00000000
    .byte   %00001100
    .byte   %00001000
    .byte   %00001100
    .byte   %01111000
    .byte   %01011000
    .byte   %00011111
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %00111100
    .byte   %00100100
    .byte   %01100110
    .byte   %11000010
    .byte   %10000010
    .byte   %10000011
    .byte   %00000000

player_sprite_right_7
    .byte   %00000000
    .byte   %00000110
    .byte   %00000100
    .byte   %00000110
    .byte   %00011100
    .byte   %00111100
    .byte   %00101110
    .byte   %00101100
    .byte   %00001100
    .byte   %00001100
    .byte   %00111000
    .byte   %00111100
    .byte   %00100100
    .byte   %11100100
    .byte   %10000100
    .byte   %00000110
    .byte   %00000000

player_sprite_right_8
    .byte   %00000000
    .byte   %00000110
    .byte   %00000100
    .byte   %00000110
    .byte   %00001100
    .byte   %00011100
    .byte   %00011100
    .byte   %00011110
    .byte   %00011000
    .byte   %00011000
    .byte   %00011000
    .byte   %11111000
    .byte   %10001000
    .byte   %10001000
    .byte   %00001000
    .byte   %00001100
    .byte   %00000000

player_sprite_crouch_left
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %01100000
    .byte   %00111100
    .byte   %01111110
    .byte   %00011110
    .byte   %00011010
    .byte   %00110110
    .byte   %01101100
    .byte   %00001100
    .byte   %00001100
    .byte   %00001111
    .byte   %00001001
    .byte   %00011001
    .byte   %00000000

player_sprite_crouch_right
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000110
    .byte   %00111100
    .byte   %01111110
    .byte   %01111000
    .byte   %01011000
    .byte   %01101100
    .byte   %00110110
    .byte   %00110000
    .byte   %00110000
    .byte   %11110000
    .byte   %10010000
    .byte   %10011000
    .byte   %00000000

player_sprite_hit_left
    .byte   %00000000
    .byte   %00000000
    .byte   %01100000
    .byte   %00100000
    .byte   %01100000
    .byte   %00110000
    .byte   %00111000
    .byte   %00111100
    .byte   %00011100
    .byte   %00011100
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %00100110
    .byte   %01100110
    .byte   %00000000

player_sprite_death_left_1
    .byte   %00000000
    .byte   %01100000
    .byte   %00000000
    .byte   %00100000
    .byte   %01100000
    .byte   %00110000
    .byte   %00111000
    .byte   %00111100
    .byte   %00011100
    .byte   %00011100
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %00100110
    .byte   %01100110
    .byte   %00000000

player_sprite_death_left_2
    .byte   %00000000
    .byte   %00000000
    .byte   %00100000
    .byte   %00000000
    .byte   %01100000
    .byte   %00110000
    .byte   %00111000
    .byte   %00111100
    .byte   %00011100
    .byte   %00011100
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %00100110
    .byte   %01100110
    .byte   %00000000

player_sprite_death_left_3
    .byte   %00000000
    .byte   %00100000
    .byte   %00000000
    .byte   %01100000
    .byte   %00000000
    .byte   %00110000
    .byte   %00111000
    .byte   %00111100
    .byte   %00011100
    .byte   %00011100
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %00100110
    .byte   %01100110
    .byte   %00000000

player_sprite_death_left_4
    .byte   %00000000
    .byte   %00000000
    .byte   %01100000
    .byte   %00000000
    .byte   %00110000
    .byte   %00000000
    .byte   %00111000
    .byte   %00111100
    .byte   %00011100
    .byte   %00011100
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %00100110
    .byte   %01100110
    .byte   %00000000

player_sprite_death_left_5
    .byte   %00000000
    .byte   %01100000
    .byte   %00000000
    .byte   %00110000
    .byte   %00000000
    .byte   %00111000
    .byte   %00000000
    .byte   %00111100
    .byte   %00011100
    .byte   %00011100
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %00100110
    .byte   %01100110
    .byte   %00000000

player_sprite_death_left_6
    .byte   %00000000
    .byte   %00110000
    .byte   %00000000
    .byte   %00111000
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00011100
    .byte   %00000000
    .byte   %00011100
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %00100110
    .byte   %01100110
    .byte   %00000000

player_sprite_death_left_7
    .byte   %00000000
    .byte   %00111000
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00011100
    .byte   %00000000
    .byte   %00011100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %00100110
    .byte   %01100110
    .byte   %00000000

player_sprite_death_left_8
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00011100
    .byte   %00000000
    .byte   %00011100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00100100
    .byte   %00100110
    .byte   %01100110
    .byte   %00000000

player_sprite_death_left_9
    .byte   %00000000
    .byte   %00000000
    .byte   %00011100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00100100
    .byte   %00000000
    .byte   %00100110
    .byte   %00000000
    .byte   %01100110
    .byte   %00000000
    .byte   %00000000

player_sprite_death_left_10
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00100100
    .byte   %00000000
    .byte   %00100110
    .byte   %00000000
    .byte   %01100110
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000

player_sprite_death_left_11
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00100100
    .byte   %00000000
    .byte   %00100110
    .byte   %00000000
    .byte   %01100110
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000

player_sprite_death_left_12
    .byte   %00000000
    .byte   %00100110
    .byte   %00000000
    .byte   %01100110
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000

player_sprite_death_right_1
    .byte   %00000000
    .byte   %00000110
    .byte   %00000000
    .byte   %00000100
    .byte   %00000110
    .byte   %00001100
    .byte   %00011100
    .byte   %00111100
    .byte   %00111000
    .byte   %00111000
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %01100100
    .byte   %01100110
    .byte   %00000000

player_sprite_death_right_2
    .byte   %00000000
    .byte   %00000000
    .byte   %00000100
    .byte   %00000000
    .byte   %00000110
    .byte   %00001100
    .byte   %00011100
    .byte   %00111100
    .byte   %00111000
    .byte   %00111000
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %01100100
    .byte   %01100110
    .byte   %00000000

player_sprite_death_right_3
    .byte   %00000000
    .byte   %00000100
    .byte   %00000000
    .byte   %00000110
    .byte   %00000000
    .byte   %00001100
    .byte   %00011100
    .byte   %00111100
    .byte   %00111000
    .byte   %00111000
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %01100100
    .byte   %01100110
    .byte   %00000000

player_sprite_death_right_4
    .byte   %00000000
    .byte   %00000000
    .byte   %00000110
    .byte   %00000000
    .byte   %00001100
    .byte   %00000000
    .byte   %00011100
    .byte   %00111100
    .byte   %00111000
    .byte   %00111000
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %01100100
    .byte   %01100110
    .byte   %00000000

player_sprite_death_right_5
    .byte   %00000000
    .byte   %00000110
    .byte   %00000000
    .byte   %00001100
    .byte   %00000000
    .byte   %00011100
    .byte   %00000000
    .byte   %00111100
    .byte   %00111000
    .byte   %00111000
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %01100100
    .byte   %01100110
    .byte   %00000000

player_sprite_death_right_6
    .byte   %00000000
    .byte   %00001100
    .byte   %00000000
    .byte   %00011100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111000
    .byte   %00000000
    .byte   %00111000
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %01100100
    .byte   %01100110
    .byte   %00000000

player_sprite_death_right_7
    .byte   %00000000
    .byte   %00011100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111000
    .byte   %00000000
    .byte   %00111000
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %01100100
    .byte   %01100110
    .byte   %00000000

player_sprite_death_right_8
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111000
    .byte   %00000000
    .byte   %00111000
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00100100
    .byte   %01100100
    .byte   %01100110
    .byte   %00000000

player_sprite_death_right_9
    .byte   %00000000
    .byte   %00000000
    .byte   %00111000
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00100100
    .byte   %00000000
    .byte   %01100100
    .byte   %00000000
    .byte   %01100110
    .byte   %00000000
    .byte   %00000000

player_sprite_death_right_10
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00100100
    .byte   %00000000
    .byte   %01100100
    .byte   %00000000
    .byte   %01100110
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000

player_sprite_death_right_11
    .byte   %00000000
    .byte   %00111100
    .byte   %00000000
    .byte   %00100100
    .byte   %00000000
    .byte   %01100100
    .byte   %00000000
    .byte   %01100110
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000

player_sprite_death_right_12
    .byte   %00000000
    .byte   %01100100
    .byte   %00000000
    .byte   %01100110
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000
    .byte   %00000000

player_sprite_hit_right
    .byte   %00000000
    .byte   %00000000
    .byte   %00000110
    .byte   %00000100
    .byte   %00000110
    .byte   %00001100
    .byte   %00011100
    .byte   %00111100
    .byte   %00111000
    .byte   %00111000
    .byte   %00111100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100100
    .byte   %01100100
    .byte   %01100110
    .byte   %00000000

player_sprite_block_left
    .byte   %00000000
    .byte   %00000000
    .byte   %00110000
    .byte   %00010000
    .byte   %00110000
    .byte   %00011000
    .byte   %00011100
    .byte   %00111100
    .byte   %00001100
    .byte   %00011100
    .byte   %00111100
    .byte   %00111100
    .byte   %00100110
    .byte   %00100110
    .byte   %00100001
    .byte   %01100011
    .byte   %00000000

player_sprite_block_right
    .byte   %00000000
    .byte   %00000000
    .byte   %00001100
    .byte   %00001000
    .byte   %00001100
    .byte   %00011000
    .byte   %00111000
    .byte   %00111100
    .byte   %00110000
    .byte   %00111000
    .byte   %00111100
    .byte   %00111100
    .byte   %01100100
    .byte   %01100100
    .byte   %10000100
    .byte   %11000110
    .byte   %00000000

; Animation tables.
player_vertical_cycle
    .word   player_sprite_vertical_1
    .word   player_sprite_vertical_2
    .word   player_sprite_vertical_1
    .word   player_sprite_vertical_3

player_left_cycle
    .word   player_sprite_left_1
    .word   player_sprite_left_2
    .word   player_sprite_left_3
    .word   player_sprite_left_4
    .word   player_sprite_left_5
    .word   player_sprite_left_6
    .word   player_sprite_left_7
    .word   player_sprite_left_8

player_right_cycle
    .word   player_sprite_right_1
    .word   player_sprite_right_2
    .word   player_sprite_right_3
    .word   player_sprite_right_4
    .word   player_sprite_right_5
    .word   player_sprite_right_6
    .word   player_sprite_right_7
    .word   player_sprite_right_8

player_left_crouch_cycle
    .word   player_sprite_crouch_left

player_right_crouch_cycle
    .word   player_sprite_crouch_right

player_left_hit_cycle
    .word   player_sprite_hit_left

player_right_hit_cycle
    .word   player_sprite_hit_right

player_left_block_cycle
    .word   player_sprite_block_left

player_right_block_cycle
    .word   player_sprite_block_right

player_left_death_cycle
    .word   player_sprite_death_left_1
    .word   player_sprite_death_left_2
    .word   player_sprite_death_left_3
    .word   player_sprite_death_left_4
    .word   player_sprite_death_left_5
    .word   player_sprite_death_left_6
    .word   player_sprite_death_left_7
    .word   player_sprite_death_left_8
    .word   player_sprite_death_left_9
    .word   player_sprite_death_left_10
    .word   player_sprite_death_left_11
    .word   player_sprite_death_left_12

player_right_death_cycle
    .word   player_sprite_death_right_1
    .word   player_sprite_death_right_2
    .word   player_sprite_death_right_3
    .word   player_sprite_death_right_4
    .word   player_sprite_death_right_5
    .word   player_sprite_death_right_6
    .word   player_sprite_death_right_7
    .word   player_sprite_death_right_8
    .word   player_sprite_death_right_9
    .word   player_sprite_death_right_10
    .word   player_sprite_death_right_11
    .word   player_sprite_death_right_12

player_idle_last_frame      equ 0
player_vertical_last_frame  equ 6
player_left_last_frame      equ 14
player_right_last_frame     equ 14
player_death_last_frame     equ 22

; Animation meta tables.  Indexed by direction.
player_animation_low_byte
    .byte   0
    .byte   <player_vertical_cycle
    .byte   <player_vertical_cycle
    .byte   <player_right_cycle
    .byte   <player_right_cycle
    .byte   <player_right_cycle
    .byte   <player_right_cycle
    .byte   <player_right_cycle
    .byte   <player_vertical_cycle
    .byte   <player_vertical_cycle
    .byte   <player_vertical_cycle
    .byte   <player_left_cycle
    .byte   <player_left_cycle
    .byte   <player_left_cycle
    .byte   <player_left_cycle
    .byte   <player_left_cycle
    .byte   <player_vertical_cycle

player_animation_high_byte
    .byte   0
    .byte   >player_vertical_cycle
    .byte   >player_vertical_cycle
    .byte   >player_right_cycle
    .byte   >player_right_cycle
    .byte   >player_right_cycle
    .byte   >player_right_cycle
    .byte   >player_right_cycle
    .byte   >player_vertical_cycle
    .byte   >player_vertical_cycle
    .byte   >player_vertical_cycle
    .byte   >player_left_cycle
    .byte   >player_left_cycle
    .byte   >player_left_cycle
    .byte   >player_left_cycle
    .byte   >player_left_cycle
    .byte   >player_vertical_cycle

player_animation_length
    .byte   player_idle_last_frame
    .byte   player_vertical_last_frame
    .byte   player_vertical_last_frame
    .byte   player_right_last_frame
    .byte   player_right_last_frame
    .byte   player_right_last_frame
    .byte   player_right_last_frame
    .byte   player_right_last_frame
    .byte   player_vertical_last_frame
    .byte   player_vertical_last_frame
    .byte   player_vertical_last_frame
    .byte   player_left_last_frame
    .byte   player_left_last_frame
    .byte   player_left_last_frame
    .byte   player_left_last_frame
    .byte   player_left_last_frame
    .byte   player_vertical_last_frame

; Disc speed tables.
key_to_disc_direction
    .byte   0,14,0,2,12,0,4,10,8,6

player_disc_x_speeds
    .byte   0,14,28,30,32,30,28,14,0,-14,-28,-30,-32,-30,-28,-14

player_disc_y_speeds
    .byte   -64,-56,-48,-24,0,24,48,56,64,56,48,24,0,-24,-48,-56

; HPOS offsets for held discs, by direction.
player_disc_offsets
    .byte   0,4,4,6,6,6,6,6,2,2,2,0,0,0,0,0,4

; Modifier for sticks, also by direction.
player_stick_offsets
    .byte   0,6,6,7,7,7,7,7,1,1,1,0,0,0,0,0,6

; Top and bottom door byte offsets.
door_offsets
    .byte   $45,$4f,$59

; Spawn locations for each door.
spawn_xpos
    .byte   84,124,164
    .byte   right_boundary - 1,right_boundary - 1, right_boundary - 1
    .byte   164,124,84
    .byte   left_boundary + 1,left_boundary + 1,left_boundary + 1

spawn_ypos
    .byte   top_boundary + 1,top_boundary + 1,top_boundary + 1
    .byte   $5f,$87,$af
    .byte   bottom_boundary - 1,bottom_boundary - 1,bottom_boundary - 1
    .byte   $af,$87,$5f

; CPU direction inversion tables.
cpu_direction_inversion_top
    .byte 9,8,7,11,10

cpu_direction_inversion_bottom
    .byte 3,2,1,16,15

cpu_direction_inversion_right
    .byte 15,14,13,12,11

cpu_direction_inversion_left
    .byte 7,6,5,4,3

cpu_basic_slow_speed_index  equ 17
cpu_basic_fast_speed_index  equ 34
player_start_speed_index    equ 34
armored_slow_speed_index    equ 17
leader_speed_index          equ 34

; Speed indices for the player and the
; armored enemies, whose speed is based
; on their current health label.  The
; first 0 is padding.
health_speed_table
    .byte 0,0,17,34,51,68

; Enemy spawn table.  Top 2 bits identify
; the enemy type, bottom six bits are the
; speed level.  Speed level is multiplied
; by 17 to get an index.  At 1,000,000+
; points, a different table is used.  The last
; entry of this table overlaps with the first
; entry in the second table.
enemy_spawn_table
    .byte   $01,$01,$01 ; Three slow normal enemies.
    .byte   $02,$01,$01 ; One faster normal enemy.
    .byte   $02,$02,$01 ; Two faster normal enemies.
    .byte   $02,$02,$02 ; Three fast normal enemies.
    .byte   $82,$02,$01 ; Leader, fast normal, slow normal.
    .byte   $02,$02,$41 ; Two fast normal, armored.
    .byte   $02,$82,$02 ; Fast normal, leader, fast normal.
    .byte   $41,$02,$02 ; Armored, two fast normal.
    .byte   $01,$41,$82 ; Faster normal, armored, leader.
    .byte   $82,$01,$82 ; Leader, faster normal, leader.
    .byte   $82,$41,$01 ; Leader, armored, faster normal.
    .byte   $82,$82,$41 ; Two leaders, armored.

; This is the 1,000,000+ point spawn table.
high_enemy_spawn_table
    .byte   $82,$82,$82 ; Leader, leader, leader.
    .byte   $82,$82,$c2 ; Leader, leader, guard.
    .byte   $82,$c2,$82 ; Leader, guard, leader.
    .byte   $82,$c2,$c2 ; Leader, guard, guard.
    .byte   $c2,$82,$82 ; Guard, leader, leader.
    .byte   $c2,$82,$c2 ; Guard, leader, guard.
    .byte   $c2,$c2,$82 ; Guard, guard, leader.

; The door for reinforcements, indexed by side.
reinforcement_doors
    .byte   0,3,8,11

    mac make_hspeed_table
    .byte 0,0,{1},{2},{3},{4},{3},{2},{1},0,-{1},-{2},-{3},-{4},-{3},-{2},-{1}
    endm

; Player speed tables.    
player_hspeed_table
    make_hspeed_table 2,4,6,8
    make_hspeed_table 4,8,10,12
    make_hspeed_table 6,12,14,16
    make_hspeed_table 8,16,18,20
    make_hspeed_table 10,20,22,24

    mac make_vspeed_table
    .byte 0,-{4},-{3},-{2},-{1},0,{1},{2},{3},{4},{3},{2},{1},0,-{1},-{2},-{3}
    endm

player_vspeed_table
    make_vspeed_table 6,12,14,16
    make_vspeed_table 9,18,21,24
    make_vspeed_table 12,24,28,32
    make_vspeed_table 15,30,35,40
    make_vspeed_table 18,36,42,48

; Facing table for blocks/crouches.
player_facing_table
    .byte 0,0,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0

; Score tables.
; These are the score levels at which point values increase.
; The first entry in each table is the offset to the digit
; to start checking from.  Values to check follow in
; big-ending format.  Values are character codes. Each entry
; is terminated by $ff.
score_thresholds
    .byte   $10,$11,$ff     ;1000
    .byte   $10,$12,$ff     ;2000
    .byte   $10,$13,$ff     ;3000
    .byte   $10,$15,$ff     ;5000
    .byte   $10,$17,$15,$ff ;7500
    .byte   $f,$11,$ff      ;10000
    .byte   $f,$11,$15,$ff  ;15000
    .byte   $f,$12,$ff      ;20000
    .byte   $f,$12,$15,$ff  ;25000
    .byte   $f,$13,$ff      ;30000
    .byte   $f,$14,$ff      ;40000
    .byte   $f,$15,$ff      ;50000
    .byte   $f,$17,$15,$ff  ;75000
    .byte   $e,$11,$ff      ;100000

max_score_level equ warrior_scores - score_thresholds

; Point values for the warriors.
; No 1s digit, since it's always 0.
warrior_scores
    .byte   5,$ff           ;50
    .byte   0,1,$ff         ;100
    .byte   5,1,$ff         ;150
    .byte   5,2,$ff         ;250
    .byte   0,3,$ff         ;300
    .byte   0,5,$ff         ;500
    .byte   5,7,$ff         ;750
    .byte   0,0,1,$ff       ;1000
    .byte   5,2,1,$ff       ;1250
    .byte   0,5,1,$ff       ;1500
    .byte   0,0,2,$ff       ;2000
    .byte   0,5,2,$ff       ;2500
    .byte   0,5,3,$ff       ;3500
    .byte   0,0,5,$ff       ;5000
    .byte   0,0,0,1,$ff     ;10000

; Recognizer sprites.  These are basically
; RLE compressed.  Count byte followed by 
; player 1 data byte, then player 2 data byte.
; 0 terminated.
recognizer_sprites_new
    .byte   2,%00000001,%10000000
    .byte   2,%00000011,%11000000
    .byte   1,%00000100,%00100000
    .byte   1,%00000000,%00000000
    .byte   2,%00001111,%11110000
    .byte   4,%11101110,%01110111
    .byte   4,%01000001,%10000010
    .byte   4,%11111110,%01111111
    .byte   4,%00000000,%00000000
    .byte   4,%11101111,%11110111
    .byte   40,%10100000,%00000101
    .byte   4,%10010000,%00001001
    .byte   4,%11111000,%00011111
    .byte   0

; Solid body recognizer.
recognizer_sprites_classic
    .byte   2,%00000001,%10000000
    .byte   2,%00000011,%11000000
    .byte   1,%00000100,%00100000
    .byte   1,%00000000,%00000000
    .byte   2,%00001111,%11110000
    .byte   20,%11111111,%11111111
    .byte   40,%11100000,%00000111
    .byte   4,%11110000,%00001111
    .byte   4,%11111000,%00011111
    .byte   0

; Recognizer paralyzer probe.
probe_sprite
    .byte   %01000010
    .byte   %00100100
    .byte   %00011000
    .byte   %00000000
    .byte   %10100101
    .byte   %01000010
    .byte   %00011000
    .byte   %01000010
    .byte   %10100101
    .byte   %00000000
    .byte   %00011000
    .byte   %00100100
    .byte   %01000010

; Sparker object.
sparker_sprite
    .byte   %00000000
    .byte   %00000010
    .byte   %00100000
    .byte   %00001010
    .byte   %01000000
    .byte   %00000000
    .byte   %00101100
    .byte   %00111000

    .byte   %00000100
    .byte   %01001001
    .byte   %00000000
    .byte   %01000010
    .byte   %00000000
    .byte   %00000000
    .byte   %00101100
    .byte   %00111000

    .byte   %00100100
    .byte   %00000001
    .byte   %10001000
    .byte   %00000010
    .byte   %00100000
    .byte   %00000000
    .byte   %00101100
    .byte   %00111000

; Door repair sequence for the recognizer.
door_repair_sequence
    .byte   0,1,2,3,4,5,8,7,6,11,10,9

; Speed and lifetime tables for the door
; repair panels.
door_repair_h_speed
    .byte   -20,0,20,40,40,40,20,0,-20,-40,-40,-40

door_repair_v_speed
    .byte   -32,-32,-32,-12,8,28,48,48,48,28,8,-12

; Position tables for players in battle mode.
battle_p1_x
    .byte 64,124,64

battle_p1_y
    .byte 134,74,74

battle_p2_x
    .byte 184,64,184

battle_p2_y
    .byte 134,194,74

battle_p3_x
    .byte 184,64

battle_p3_y
    .byte 194,194

battle_p4_x equ 184
battle_p4_y equ 194

; Initial color table for title logo.
title_table
    .byte $0c,$0a,$08,$06,$04,$02
    .byte $04,$06,$08,$0a,$0c,$0e,$1e

; Sound resources.
; Format is: AUDC value, then a 0 terminated sequence
; of AUDF value + duration in frames pairs.
; Special frequency values:
; ff: Rest period, play nothing.
; fe: AUDC change, byte that follows is the new AUDC.
; Special timing values:
; ff: Continuous sound. No 0 terminator in this case.
player_hit_sound
    .byte   $cf
    .byte   $50,10
    .byte   0

player_death_sound
    .byte   $cf
    .byte   $10,10
    .byte   $20,10
    .byte   $30,10
    .byte   0

disc_throw_sound
    .byte   $cf
    .byte   $c0,1
    .byte   $c1,1
    .byte   $c2,1
    .byte   $c1,1
    .byte   $c3,1
    .byte   $c2,1
    .byte   $c5,1
    .byte   $c4,1
    .byte   $c7,1
    .byte   $c6,1
    .byte   0

music_track_1
    .byte $a8
    .byte $6A,15,$64,15,$5E,60,$6A,15,$64,15,$5E,30,$6A,30,$56,45
	.byte $64,45,$6E,45,$62,30,$74,15,$6E,15,$6A,60,$74,15,$6E,15
	.byte $6A,30,$74,30,$5E,45,$6E,45,$5C,45,$77,45
	.byte $74,15,$62,15,$6E,30,$74,30,$6E,120,$6A,15,$6E,15,$74,30
	.byte $6A,30,$64,90,$61,15,$67,15,$6E,30,$61,30,$59,60,$8C,60
	.byte $59,15,$5E,15,$64,30,$59,30,$51,60,$5E,60,$0

music_track_2
    .byte $a8
    .byte $62,30,$5C,30,$62,30,$5C,30,$62,30,$5C,30,$6E,15,$6E,15
	.byte $6E,15,$7D,15,$7D,15,$86,15,$7D,15,$7D,15,$86,15,$6E,15
	.byte $2D,15,$95,30,$8C,30,$95,30,$8C,30,$95,30,$8C,30,$5C,15
	.byte $5C,15,$5C,15,$95,15,$95,15,$9E,15,$95,15,$95,15,$9E,60
	.byte $6E,60,$6E,120,$95,30,$86,60,$77,90,$9E,210,$86,210,$71,30,$0

music_track_3
    .byte $a8
    .byte $ff,180,$61,15,$61,15,$64,15,$6E,15,$6E,15,$6E,15,$62,15
	.byte $62,15,$62,15,$86,210,$6A,15,$6A,15,$6E,15,$5C,15,$5C,15
	.byte $5C,15,$77,15,$77,15,$77,15,$9E,45
	.byte $ff,90,$7D,30,$86,15,$95,15,$9E,30,$B3,90,$6E,30,$77,15
	.byte $86,15,$95,150,$71,30,$6E,15,$6A,15,$67,10,$74,15,$6E,15
	.byte $67,15,$64,15,$77,15,$5B,15,$59,30,$0

; Text assets.
high_score_text
    .byte "High score:",$0

low_score_text
    .byte "Low  score:",$0

last_score_text
    .byte "Last score:",$0

none_text
    .byte "None",$0

hero_text
    .byte "Your man",$0

drone_text
    .byte "Drone",$0

armored_text
    .byte "Armored",$0

guard_text
    .byte "Guard",$0

leader_text
    .byte "Leader",$0

hunter_text
    .byte "Hunter",$0

seeker_text
    .byte "Seeker",$0

press_start_text
    .byte "Press Start to play",$0

press_for_license_text
    .byte "Press # to view license",$0

select_game_mode_text
    .byte "Select game mode:",$0

one_player_text
    .byte "1 - Arcade mode",$0

battle_player_text
    .byte "2 - 2 player battle",$0

control_mode_text
    .byte "Control mode:",$0

control_keypad_text
    .byte "* - Keypad    ",$0

control_trigger_text
    .byte "Trigger   ",$0

control_twin_text
    .byte "Twin stick",$0

identifier_style_text
    .byte "Identifier body style:",$0

identifier_new_text
    .byte "# - New    ",$0

identifier_classic_text
    .byte "Classic",$0

copyright_text
    .byte "Copyright MMXXI Phaser Cat Games LLC",$0
                                                     
;    .byte   "Intellidiscs is free software: you can  "
;    .byte   "redistribute it and/or modify it under  "
;    .byte   "the terms of the GNU General Public     "
;    .byte   "License as published by the Free        "
;    .byte   "Software Foundation, either version 3 of"
;    .byte   "the License, or (at your option) any    "
;    .byte   "later version.                          "
;    .byte   "Intellidiscs is distributed in the hope "
;    .byte   "that it will be useful, but WITHOUT ANY "
;    .byte   "WARRANTY; without even the implied      "
;    .byte   "warranty of MERCHANTABILITY or FITNESS  "
;    .byte   "FOR A PARTICULAR PURPOSE.  See the GNU  "
;    .byte   "General Public License for more details."
;    .byte   "You should have received a copy of the  "
;    .byte   "GNU General Public License along with   "
;    .byte   "Intellidiscs.  If not, see              "
;    .byte   "<http://www.gnu.org/licenses/>.         "
;    .byte   " Press # to return to the title screen  "

; This is the license text pre-converted from ASCII to the
; proper character codes for mode 2.  This allows the
; license display list to show the data directly from
; the cartridge.
gpl_text
    .byte $29,$6e,$74,$65,$6c,$6c,$69,$64,$69,$73,$63,$73,$0,$69,$73,$0,$66,$72,$65,$65,$0,$73,$6f,$66,$74,$77,$61,$72,$65,$1a,$0,$79,$6f,$75,$0,$63,$61,$6e,$0,$0
    .byte $72,$65,$64,$69,$73,$74,$72,$69,$62,$75,$74,$65,$0,$69,$74,$0,$61,$6e,$64,$f,$6f,$72,$0,$6d,$6f,$64,$69,$66,$79,$0,$69,$74,$0,$75,$6e,$64,$65,$72,$0,$0
    .byte $74,$68,$65,$0,$74,$65,$72,$6d,$73,$0,$6f,$66,$0,$74,$68,$65,$0,$27,$2e,$35,$0,$27,$65,$6e,$65,$72,$61,$6c,$0,$30,$75,$62,$6c,$69,$63,$0,$0,$0,$0,$0
    .byte $2c,$69,$63,$65,$6e,$73,$65,$0,$61,$73,$0,$70,$75,$62,$6c,$69,$73,$68,$65,$64,$0,$62,$79,$0,$74,$68,$65,$0,$26,$72,$65,$65,$0,$0,$0,$0,$0,$0,$0,$0
    .byte $33,$6f,$66,$74,$77,$61,$72,$65,$0,$26,$6f,$75,$6e,$64,$61,$74,$69,$6f,$6e,$c,$0,$65,$69,$74,$68,$65,$72,$0,$76,$65,$72,$73,$69,$6f,$6e,$0,$13,$0,$6f,$66
    .byte $74,$68,$65,$0,$2c,$69,$63,$65,$6e,$73,$65,$c,$0,$6f,$72,$0,$8,$61,$74,$0,$79,$6f,$75,$72,$0,$6f,$70,$74,$69,$6f,$6e,$9,$0,$61,$6e,$79,$0,$0,$0,$0
    .byte $6c,$61,$74,$65,$72,$0,$76,$65,$72,$73,$69,$6f,$6e,$e,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0
    .byte $29,$6e,$74,$65,$6c,$6c,$69,$64,$69,$73,$63,$73,$0,$69,$73,$0,$64,$69,$73,$74,$72,$69,$62,$75,$74,$65,$64,$0,$69,$6e,$0,$74,$68,$65,$0,$68,$6f,$70,$65,$0
    .byte $74,$68,$61,$74,$0,$69,$74,$0,$77,$69,$6c,$6c,$0,$62,$65,$0,$75,$73,$65,$66,$75,$6c,$c,$0,$62,$75,$74,$0,$37,$29,$34,$28,$2f,$35,$34,$0,$21,$2e,$39,$0
    .byte $37,$21,$32,$32,$21,$2e,$34,$39,$1b,$0,$77,$69,$74,$68,$6f,$75,$74,$0,$65,$76,$65,$6e,$0,$74,$68,$65,$0,$69,$6d,$70,$6c,$69,$65,$64,$0,$0,$0,$0,$0,$0
    .byte $77,$61,$72,$72,$61,$6e,$74,$79,$0,$6f,$66,$0,$2d,$25,$32,$23,$28,$21,$2e,$34,$21,$22,$29,$2c,$29,$34,$39,$0,$6f,$72,$0,$26,$29,$34,$2e,$25,$33,$33,$0,$0
    .byte $26,$2f,$32,$0,$21,$0,$30,$21,$32,$34,$29,$23,$35,$2c,$21,$32,$0,$30,$35,$32,$30,$2f,$33,$25,$e,$0,$0,$33,$65,$65,$0,$74,$68,$65,$0,$27,$2e,$35,$0,$0
    .byte $27,$65,$6e,$65,$72,$61,$6c,$0,$30,$75,$62,$6c,$69,$63,$0,$2c,$69,$63,$65,$6e,$73,$65,$0,$66,$6f,$72,$0,$6d,$6f,$72,$65,$0,$64,$65,$74,$61,$69,$6c,$73,$e
    .byte $39,$6f,$75,$0,$73,$68,$6f,$75,$6c,$64,$0,$68,$61,$76,$65,$0,$72,$65,$63,$65,$69,$76,$65,$64,$0,$61,$0,$63,$6f,$70,$79,$0,$6f,$66,$0,$74,$68,$65,$0,$0
    .byte $27,$2e,$35,$0,$27,$65,$6e,$65,$72,$61,$6c,$0,$30,$75,$62,$6c,$69,$63,$0,$2c,$69,$63,$65,$6e,$73,$65,$0,$61,$6c,$6f,$6e,$67,$0,$77,$69,$74,$68,$0,$0,$0
    .byte $29,$6e,$74,$65,$6c,$6c,$69,$64,$69,$73,$63,$73,$e,$0,$0,$29,$66,$0,$6e,$6f,$74,$c,$0,$73,$65,$65,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0,$0
    .byte $1c,$68,$74,$74,$70,$1a,$f,$f,$77,$77,$77,$e,$67,$6e,$75,$e,$6f,$72,$67,$f,$6c,$69,$63,$65,$6e,$73,$65,$73,$f,$1e,$e,$0,$0,$0,$0,$0,$0,$0,$0,$0
    .byte $0,$30,$72,$65,$73,$73,$0,$3,$0,$74,$6f,$0,$72,$65,$74,$75,$72,$6e,$0,$74,$6f,$0,$74,$68,$65,$0,$74,$69,$74,$6c,$65,$0,$73,$63,$72,$65,$65,$6e,$0,$0

