; This file is part of Intellidiscs.

; Intellidiscs is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; Intellidiscs is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with Intellidiscs.  If not, see <http://www.gnu.org/licenses/>.

; Copyright 2021 Phaser Cat Games LLC

; Intellidiscs
; Assemble with DASM command line:
; dasm intellidiscs.s -f3 -ointellidiscs.bin

    processor 6502

    include "hardware.s"
    include "instructions.s"

    org     $4000                   ; Cartridge memory.
    jsr     init_system             ; Run one-time startup code.
    jmp     start_intro

    include "startup.s"
    include "utilities.s"
    include "intro.s"
    include "title_screen.s"
    include "game.s"
    include "keypads.s"
    include "title_logo.s"
    include "interrupts.s"
    include "phaser_cat_logo.s"
    include "sound_engine.s"
    include "tileset.s"
    include "data.s"

    org     $bf00                   ; Build watermark.
build_id
    .byte   "Release 1.0, 5/15/2021",$0

    org     $bfe7                   ; PAL flag.
    .byte   $00

    org     $bffd                   ; Cartridge reset data.
    .byte   $ff                     ; No copyright screen.
    .word   $4000                   ; Code starts at $4000.

