; This file is part of Intellidiscs.

; Intellidiscs is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; Intellidiscs is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with Intellidiscs.  If not, see <http://www.gnu.org/licenses/>.

; Copyright 2021 Phaser Cat Games LLC

; DLI routines.

    org     $9000
; Colorize the title logo, the switch to text color.
title_interrupt subroutine
    pha
    tya
    pha

    ldy     #0
.title_loop
    sta     WSYNC
    lda     title_color_table,y
    beq     .done_title
    sta     WSYNC
    sta     COLPF0
    iny
    jmp     .title_loop
.done_title
    lda     #armored_color
    ldy     #58
.first_loop
    sta     WSYNC
    dey
    bpl     .first_loop
    sta     COLPM1
    ldy     #double_color
    sty     COLPM2
    ldy     #20
    lda     #guard_color
.second_loop
    sta     WSYNC
    dey
    bpl     .second_loop
    sta     COLPM1
    ldy     #seeker_color
    sty     COLPM2

    pla
    tay
    pla
    rti

; Switch to the tileset after the score line.
; Change from the text to playfield color.
game_interrupt subroutine
    pha
    txa
    pha
    tya
    pha
    
    lda     #$a0
    ldx     #$84
    ldy     #$86
    sta     WSYNC
    sta     CHBASE
    stx     COLPF0
    sty     COLPF1
    lda     #$46
    sta     COLPF2
    lda     #$1e
    sta     COLPF3

    pla
    tay
    pla
    tax
    pla
    rti

