; This file is part of Intellidiscs.

; Intellidiscs is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; Intellidiscs is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with Intellidiscs.  If not, see <http://www.gnu.org/licenses/>.

; Copyright 2021 Phaser Cat Games LLC

; Initial logo introduction state

; Data.
intro_phase_timer   equ $80
intro_phase         equ $81
intro_fade_control  equ $82

; Introduction warmup.
start_intro subroutine
    mwa     high_score_text,$fc
    mwa     $224,$fe
    jsr     copy_text_full
    mwa     low_score_text,$fc
    mwa     $24c,$fe
    jsr     copy_text_full
    mwa     last_score_text,$fc
    mwa     $274,$fe
    jsr     copy_text_full
    mwa     none_text,$fc
    mwa     $290,$fe
    jsr     copy_text_full
    ldy     #3
.none_loop
    lda     $290,y
    sta     $268,y
    sta     $240,y
    dey
    bpl     .none_loop
    jsr     keypad_init
    lda     #$70                    ; Build a display list.
    ldy     #10                     ; Push the logo to the middle.
.overscan_loop
    sta     $400,y
    dey
    bpl     .overscan_loop
    lda     #$4f                    ; Mode F with LMS.
    sta     $40a
    lda     #$00                    ; Read from $3000.
    sta     $fe
    sta     $40b
    lda     #$30
    sta     $40c
    sta     $ff
    lda     #$0f
    ldy     #84                     ; 85 more lines of F.
.mode_f_loop
    sta     $40d,y
    dey
    bpl     .mode_f_loop
    lda     #$41                    ; Terminate the list.
    sta     $40d + 85
    lda     #$00
    sta     $40d + 86
    sta     sDLISTL
    lda     #$04
    sta     $40d + 87
    sta     sDLISTH
    mwa     logo_vblank,VVBLKD
    mwa     phaser_cat_logo,$fc
    jsr     decompress_monochrome
    mva     #240,intro_phase_timer
    jsr     complete_transition

; Main intro loop.
intro_loop subroutine
    jsr     wait_for_vb
    jsr     keypad_process
    lda     keypad_last_key
    bpl     .skip_intro
    lda     TRIG0
    beq     .skip_intro
    lda     keypad_shift
    bne     .process_intro
.skip_intro
    jmp     start_title_screen
.process_intro
    lda     intro_fade_control
    eor     #$80
    sta     intro_fade_control
    lda     intro_phase
    beq     .fade_in
    cmp     #1
    beq     .hold
    bit     intro_fade_control
    bpl     intro_loop
    ldx     sCOLOR1
    beq     .skip_intro
    dex
    stx     sCOLOR1
    jmp     intro_loop
.fade_in
    bit     intro_fade_control
    bpl     intro_loop
    ldx     sCOLOR1
    inx
    stx     sCOLOR1
    cpx     #$f
    beq     .next_phase
    jmp     intro_loop
.hold
    dec     intro_phase_timer
    bne     intro_loop
.next_phase
    inc     intro_phase
    jmp     intro_loop

; Logo vertical blank routine.
logo_vblank subroutine
    jsr     keypad_cooldown_process
    jmp     ENDINT

